package jp.hishidama.swing.table.editor;

import java.awt.Color;
import java.awt.Component;

import javax.swing.DefaultCellEditor;
import javax.swing.JTable;
import javax.swing.border.LineBorder;

import jp.hishidama.swing.undo.UndoTextField;

/**
 * intGfB^[.
 *
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/tech/java/swing/JTable.html"
 *         >Ђ</a>
 * @since 2009.09.27
 */
public class IntEditor extends DefaultCellEditor {
	private static final long serialVersionUID = -8368795944481669400L;

	protected Integer dvalue;

	/** RXgN^[. */
	public IntEditor() {
		super(new UndoTextField());
		getComponent().setHorizontalAlignment(UndoTextField.RIGHT);
	}

	@Override
	public UndoTextField getComponent() {
		return (UndoTextField) super.getComponent();
	}

	/**
	 * ҏWJnɌĂ΂.
	 *
	 * @param table
	 *            Ώۃe[u
	 * @param value
	 *            ҏWΏۃf[^ilj
	 * @param isSelected
	 * @param row
	 *            f[^̂sԍ
	 * @param column
	 *            f[^̂ԍ
	 * @return `pR|[lg
	 */
	@Override
	public Component getTableCellEditorComponent(JTable table, Object value,
			boolean isSelected, int row, int column) {
		this.dvalue = null; // 
		getComponent().setBorder(new LineBorder(Color.black)); // ŏ͍g

		String str = (value == null) ? "" : value.toString();
		UndoTextField utf = (UndoTextField) super.getTableCellEditorComponent(
				table, str, isSelected, row, column);
		utf.clearUndoEdit();
		return utf;
	}

	/**
	 * ҏWɌĂ΂.
	 * <p>
	 * super.stopCellEditing()ĂяoƐIƂȂ͗lB
	 * </p>
	 *
	 * @return truȅꍇAIiƎv邪Aۂɂ͉ԂĂ֌Wۂj
	 */
	@Override
	public boolean stopCellEditing() {
		Integer d = null;

		String str = (String) super.getCellEditorValue(); // ҏWꂽl̎擾
		if (str != null && !str.isEmpty()) {
			try {
				d = Integer.valueOf(str);
			} catch (Exception e) {
				// G[͐Ԙg\
				getComponent().setBorder(new LineBorder(Color.red));
				return false;
			}
		}

		this.dvalue = d; // Ԃl(ҏWꂽl)ێĂ

		return super.stopCellEditing();
		// super.stopCellEditing()̒getCellEditorValue()Ă΂A
		// JTable#setValueAt()ɂĒlZbgA
		// ҏWpR|[lgA
		// ҏW
	}

	/**
	 * ͂ꂽl(Hς)Ԃ.
	 *
	 * @return ҏWꂽl
	 */
	@Override
	public Object getCellEditorValue() {
		return dvalue;
	}
}
